<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3DBField
  {
   // Arrays

   // Variables
   private $name,$type,$lenght,$flags;
   private $unsigned,$decimals;
   
   function __construct($name,$type,$lenght = 255,$flags = 0,$unsigned = false)
    {
	 $this->name      = $name;
	 $this->type      = $type;
     $this->decimals  = 0;
     $this->unsigned  = $unsigned;
     $this->flags     = $flags;
	 if(is_array($lenght)) {
		                    $this->lenght   = $lenght[0];
	                        $this->decimals = $lenght[1];
						   }
     else                   $this->lenght   = $lenght;
	}

   public function getName()     { return $this->name; }

   public function getType()     { return $this->type; }

   public function getLenght()   { return $this->lenght; }

   public function getFlags()    { return $this->flags; }

   public function getUnsigned() { return $this->unsigned; }

   public function getDecimals() { return $this->decimals; }

   public function isPrimaryKey()    { return $this->flags & WM3_cDB_PRIMARY_KEY; }

   public function isKey()           { return $this->flags & WM3_cDB_KEY; }

   public function isAutoIncrement() { return $this->flags & WM3_cDB_AUTO_INCREMENT; }
   
   public function isUnique()        { return $this->flags & WM3_cDB_UNIQUE; }
   
   public function isUniqueKey()     { return $this->flags & WM3_cDB_UNIQUE_KEY; }
   
   public function isNotNull()       { return $this->flags & WM3_cDB_NOT_NULL; }

  }

?>
