<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3GUIButton extends wm3GUIField
  {
   // Arrays

   // Variables
   private $type_submit,$type_reset,$type_button;

   function __construct($name,$value = '',$label = '')
    {
	 parent::__construct($name,$value,$label);
	 $this->type_submit = true;
	 $this->type_reset  = false;
	 $this->type_button = false;
    }

   public function render()
    {
	 // Render button
     //$this->value = wm3Util::quoteHTML($this->value);
     if($this->type_submit) $type = 'submit';
     if($this->type_reset)  $type = 'reset';
     if($this->type_button) $type = 'button';
     if(!$this->id) $str = "<input type=\"$type\" name=\"$this->name\" value=\"$this->value\" $this->javascript $this->inactive>";
     else           $str = "<input id=\"$this->id\" type=\"$type\" name=\"$this->name\" value=\"$this->value\" $this->javascript $this->inactive>";
     return $this->extra_content_before.$str.$this->extra_content_after;     
	}

   public function setTypeSubmit() {
	                                $this->type_reset = $type->type_button = false;
	                                $this->type_submit = true;
	                               }

   public function setTypeReset() {
	                               $this->type_submit = $type->type_button = false;
	                               $this->type_reset = true;
	                              }

   public function setTypeButton() {
	                                $this->type_submit = $type->type_reset = false;
	                                $this->type_button = true;
	                               }

  }

?>
