<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Kernel
  {

   function __construct() { }

   public static function execute($w3,$action)
    {
     // Execute a kernel action
     switch($action)
      {
	   case WM3_cACTION_KERNEL_RENDER_SELECT_IMAGES:
	    {
		 if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
		  {
		   $f = new wm3GUISelect('img_picture','','',wm3Util::selectDirectory(WM3_cPATH_IMAGES));
           return $f->render();
	      }
		 break;
		}
	   case WM3_cACTION_KERNEL_GET_DOWNLOAD:
	    {
         // Download diretto di un downloadID TODO fare bene (da wm3Folder ( vedi downloadFolderFileMd5() )
         //if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_FOLDERS)) // TODO fare permesso corretto
         //TODO fare funzione in wm3Download ...
         $downloadID = $w3->getVariable('downloadID','get');
         $rs = $w3->getDBObj()->query("SELECT download FROM ".WM3_cCONFIG_DB_PREFIX."_downloads
                                 WHERE downloadID = '$downloadID'");
         $row = $w3->getDBObj()->fetch($rs);
         if($row) $file = $row->download; else $file = '';
         $path = WM3_cPATH_DOWNLOADS;
         if(file_exists($path.$file) && $row)
          {
		   wm3Download::hitDownload($w3); // Controllare se hitdownload funziona bene
           //$content = file_get_contents($path.$file);
           // Provare a vedere se con un redirect viene meglio ...
           header("Location: ".$path.$file);
		   //header("Content-type: application/force-download"); 
           //header("Content-Disposition: attachment; filename=\"$file\"");
           //echo $content;
//         die;
	      }
         break;
		}
	   case WM3_cACTION_KERNEL_RENDER_PAGE_EDITOR:
	    {
		 // Render normal editor buttons
		 //if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
		  {
		   return wm3Util::renderEditor($w3,'document.wm3_form','document.wm3_form.editor_textarea','document.wm3_form.render_mode',1,true);
	      }
		 break;
		}
	   case WM3_cACTION_KERNEL_RENDER_PAGE_EDITOR_TINYMCE:
	    {
         // Render TinyMCE editor buttons
		 //if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
		  {
		   return wm3Util::renderEditor($w3,'document.wm3_form','document.wm3_form.editor_textarea','document.wm3_form.render_mode',1);
	      }
		 break;
		}
	   case WM3_cACTION_KERNEL_RENDER_NEWS_EDITOR:
	    {
		 // Render normal editor buttons
		 //if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
		  {
		   return wm3Util::renderEditor($w3,'document.wm3_form','document.wm3_form.editor_textarea','document.wm3_form.render_mode',2,true);
	      }
		 break;
		}
	   case WM3_cACTION_KERNEL_RENDER_NEWS_EDITOR_TINYMCE:
	    {
         // Render TinyMCE editor buttons
		 //if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
		  {
		   return wm3Util::renderEditor($w3,'document.wm3_form','document.wm3_form.editor_textarea','document.wm3_form.render_mode',2);
	      }
		 break;
		}
	   case WM3_cACTION_KERNEL_RENDER_NEWSLETTER_EDITOR:
	    {
		 // Render normal editor buttons
		 //if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
		  {
		   return wm3Util::renderEditor($w3,'document.wm3_form','document.wm3_form.editor_textarea','document.wm3_form.newsletter_format',6,true);
	      }
		 break;
		}
	   case WM3_cACTION_KERNEL_RENDER_NEWSLETTER_EDITOR_TINYMCE:
	    {
         // Render TinyMCE editor buttons
		 //if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
		  {
		   return wm3Util::renderEditor($w3,'document.wm3_form','document.wm3_form.editor_textarea','document.wm3_form.newsletter_format',6);
	      }
		 break;
		}
	   case WM3_cACTION_KERNEL_TINYMCE_JS_IMAGE_LIST:
	    {
		 // Render TinyMCE javascript image list array
		 //if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
		  {
           $_ARRAY = wm3Util::selectDirectory(WM3_cPATH_IMAGES);
           $js =  "var tinyMCEImageList = new Array(";
           for($i = 0; $i < count($_ARRAY); $i++)
            {
             $name = str_replace("'","\'",$_ARRAY[$i]->getValue());
             $js .= "['$name','".WM3_cPATH_IMAGES.$name."']";
             if($i != count($_ARRAY)-1) $js .= ",";
		    }
	       $js .= ")";
           header("content-type: application/x-javascript");	       
		   echo $js;
	      }
		 break;
		}
	   case WM3_cACTION_KERNEL_TINYMCE_JS_LINK_LIST:
	    {
		 // Render TinyMCE javascript link list array
         $n = 0; $_ARRAY_PAGE = $_ARRAY_FILE = $_ARRAY_SUBCHANNEL = array();
         //TODO fare permessi ..
         //if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_PAGES))
         $_ARRAY_PAGE       = wm3Page::selectPage($w3);
         $_ARRAY_FILE       = wm3Util::selectDirectory(WM3_cPATH_DOWNLOADS);
         $w3->getSectionObj()->setParameters(wm3Channel::getSectionParameters());
         $_ARRAY_SUBCHANNEL = wm3Channel::selectChannelSubcategory($w3);
         $js =  "var tinyMCELinkList = new Array(";
         for($i = 0; $i < count($_ARRAY_PAGE); $i++)
          {
		   $name = str_replace("'","\'",wm3Util::quoteHTML($_ARRAY_PAGE[$i]->getName()));
           $js .= "['[Page] $name','".WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_PAGES."&pageID=".$_ARRAY_PAGE[$i]->getValue()."']";
           if($i != count($_ARRAY_PAGE)-1) $js .= ",";
           $n++;
		  }
         for($i = 0; $i < count($_ARRAY_FILE); $i++)
          {
           if($n != 0 && $i == 0) $js .= ",";
		   $name = str_replace("'","\'",$_ARRAY_FILE[$i]->getValue());
           $js .= "['[File] $name','".WM3_cPATH_DOWNLOADS.$name."']";
           if($i != count($_ARRAY_FILE)-1) $js .= ",";
           $n++;
		  }
         for($i = 0; $i < count($_ARRAY_SUBCHANNEL); $i++)
          {
           if($n != 0 && $i == 0) $js .= ",";
		   $name = str_replace("'","\'",wm3Util::quoteHTML($_ARRAY_SUBCHANNEL[$i]->getName()));
           $js .= "['[Subchannel] $name','".WM3_cCONFIG_HOME_FILE."?section=".WM3_cSECTION_CHANNELS."&subchannelID=".$_ARRAY_SUBCHANNEL[$i]->getValue()."']";
           if($i != count($_ARRAY_SUBCHANNEL)-1) $js .= ",";
           $n++;
		  }
	     $js .= ")";
         header("content-type: application/x-javascript");	       
		 echo $js;
		 break;
		}
	   case WM3_cACTION_KERNEL_JS_CONSTANTS:
	    {
		 // Render javascript constants
         header("content-type: application/x-javascript");
		 echo wm3Util::renderJavaScriptConstants($w3);
		 break;
		}
	   case WM3_cACTION_KERNEL_UPLOAD_FILE:
	    {
		 if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_FOLDERS))
		  {
		   $_FIELD = webmatic3::getPostValueArray(wm3Folder::getFolderFileFieldsArray());
           $_ARRAY = wm3Folder::getFolderFieldsArray($w3);
           $_MIME  = wm3Folder::mimeTypeImage();
           $error = wm3Folder::uploadFile('file1',$_ARRAY['path'][$_FIELD['path1ID']],$_FILES['file1']['name'],$_FIELD['overwrite1'],$_MIME);
           if($error!=4) echo "<script>alert('Upload failed! $error')</script>";
           else          echo wm3Util::renderImg($_FILES['file1']['name'],'',0,0,WM3_cPATH_IMAGES);
	      }
         break;
		}
	   case WM3_cACTION_KERNEL_HTACCESS:
	    {
		 // Render .htaccess file for url rewrite
		 if(wm3User::isSuperUser($w3,$w3->getAuthenticateAdminID()))
		  {
           header("content-type: text/plain");
		   echo wm3Url::renderHtaccess();
	      }
		 break;
		}		
		//TODO fare anche generatore del file .htaccess per l'url rewrite ...
/*	   case WM3_cACTION_KERNEL_???:
	    {
		 if($w3->getAuthenticateAdminID() && wm3User::checkAdminPermission($w3,WM3_cSECTION_FOLDERS))
          return new wm3GUIFileField('file1')->render();//TODO...
		 break;
		}*/
       default: { return ''; } // No action specified
      }
     return '';
    }

  }

?>
