<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Metatag
  {

   function __construct() { }

   public static function getMetatagFieldsArray()
    {
     return array('author','keywords','description','head_extra','languageID');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       default:
        {
         return wm3Metatag::editMetatag($w3);
        }
      }
    }

   public static function editMetatag($w3)
    {
	 // Initialize form
	 $action = 0; // No action
	 require(WM3_cPATH_INCLUDE.'admin_metatag_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit metatags");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_metatags");
       $row = $w3->getDBObj()->fetch($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Metatag::getMetatagFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Metatag::getMetatagFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate()) wm3Metatag::updateMetatag($w3);
      }
     return $form->render();
    }

   public static function updateMetatag($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Metatag::getMetatagFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_metatags
                       SET author      = '".$_FIELD['author']."',
                           keywords    = '".$_FIELD['keywords']."',
                           description = '".$_FIELD['description']."',
                           head_extra  = '".$_FIELD['head_extra']."'");
    }

   public static function renderMetatags($w3)
    {
     // Render metatags
     $content_type = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
     if($w3->getStage() == WM3_cSTAGE_HOME)
      {
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_metatags");
       if($w3->getDBObj()->totalRows($rs) != 1) return $content_type.''; // No metatags found
       $row = $w3->getDBObj()->fetch($rs);
       $content_type .= "  <meta name=\"author\"      content=\"".$row->author."\" />\n";
       $content_type .= "  <meta name=\"keywords\"    content=\"".$row->keywords."\" />\n";
       $content_type .= "  <meta name=\"description\" content=\"".$row->description."\" />\n";
       $content_type .= "  $row->head_extra\n";
	  }
	 return $content_type.wm3Social::renderSocialMetatags($w3);
    }

  }

?>
